/**
 * Copyright  2002 Sun Microsystems, Inc. All rights reserved.
 */

package edu.cmu.fantango.servlet;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.naming.*;
import javax.servlet.http.*;
import javax.rmi.PortableRemoteObject;
import javax.ejb.*;

import edu.cmu.fantango.ejb.*;

/**
 * This servlet is responsible for throwing the html pages for the FanTango application.
 */
public class MovieServlet extends HttpServlet {

   /**
    * The doGet method of the servlet. Handles all http GET request.
    * Required by the servlet specification.
    * @exception throws ServletException and IOException.
    */
   public void doGet (HttpServletRequest request,HttpServletResponse response)
        throws ServletException, IOException {

        javax.ejb.Handle beanHandle;
        Movie myMovieBean;
        MovieHome myMovieHome;
        Movie myMovieRemote;

        InitialContext initContext = null;
        Hashtable env = new java.util.Hashtable(1);
        ResourceBundle rb = ResourceBundle.getBundle("LocalStrings", Locale.getDefault());

        System.out.println("\n"+rb.getString("greeting_servlet")+ "...");

        System.out.println(rb.getString("retrieving_jndi"));
        try {
            initContext = new javax.naming.InitialContext();
        }
        catch (Exception e) {
          System.out.println(rb.getString("exception")+": " + e.toString());
          return;
        }

        try {
            System.out.println(rb.getString("looking_up"));
            String JNDIName = "java:comp/env/ejb/movie";
            System.out.println(rb.getString("looking")+": " + JNDIName);
            Object objref = initContext.lookup(JNDIName);
            myMovieHome = (MovieHome)PortableRemoteObject.narrow(objref,
                                            MovieHome.class);
        }
        catch(Exception e) {
          System.out.println(rb.getString("movie_bean")+" - " +
           rb.getString("is_registered")+"?: " + e.toString());
        return;
        }
        try {
            System.out.println(rb.getString("creating"));
            myMovieRemote = myMovieHome.create();
        }
        catch(CreateException e) {
            System.out.println(rb.getString("could_not")+": "+
            e.toString());
            return;
        }

        System.out.println(rb.getString("getting"));
        String theMessage = myMovieRemote.getMovies();
        String theTime = myMovieRemote.getTime();
        System.out.println(rb.getString("got")+": " + theMessage + " for " + theTime );

        System.out.println(rb.getString("storing"));
        request.setAttribute("message", theMessage);
        request.setAttribute("time", theTime);

        System.out.println(rb.getString("dispatching"));
        response.setContentType("text/html");
        RequestDispatcher dispatcher;
        dispatcher = getServletContext().getRequestDispatcher("/MovieView.jsp");
        dispatcher.include(request, response);
        return;
    }

   /**
    * The doPost method of the servlet. Handles all http POST request.
    * Required by the servlet specification.
    * @exception throws ServletException and IOException.
    */
    public void doPost (HttpServletRequest request,HttpServletResponse response)
    throws ServletException, IOException {
        doGet(request,response);
    }

   /**
    * Returns the servlet info as a String.
    * @return returns the servlet info as a String.
    */
    public String getServletInfo() {
        ResourceBundle rb = ResourceBundle.getBundle("LocalStrings", Locale.getDefault());
        return rb.getString("call")+".";
    }
}
